/****** Script Date: 11/03/2019 11:55 ******/
------------------------------------------------------------------------------------------------------------------------------------------
IF (OBJECT_ID('mxf_vw_icms', 'V') IS NOT NULL)
DROP VIEW [dbo].[mxf_vw_icms]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-- ICMS
CREATE VIEW [dbo].[mxf_vw_icms]
AS
SELECT
	P.CODPROD AS codigo_produto, P.CODBARRA AS ean, NULL AS tipo_mva, P.PERCALIQSUBTRIB AS mva,
	SUBSTRING(T.SITTRIB, 2,2) AS sac_cst, c.CODCEST as cest,ANF.PERCENTUAL AS sac_alq, P.PERCALIQSUBTRIB AS sac_alq_st, P.PERCREDUC AS sac_rbc, NULL AS sac_rbc_st, 
	SUBSTRING(T.SITTRIB, 2,2) AS sas_cst, ANF.PERCENTUAL AS sas_alq, P.PERCALIQSUBTRIB AS sas_alq_st, P.PERCREDUC AS sas_rbc, NULL AS sas_rbc_st, 
	SUBSTRING(T.SITTRIB, 2,2) AS svc_cst, ANF.PERCENTUAL AS svc_alq, P.PERCALIQSUBTRIB AS svc_alq_st, P.PERCREDUC AS svc_rbc, NULL AS svc_rbc_st, 
	SUBSTRING(T.SITTRIB, 2,2) AS snc_cst, AECF.PERCENTUAL AS snc_alq, P.PERCALIQSUBTRIB AS snc_alq_st, P.PERCREDUC AS snc_rbc, NULL AS snc_rbc_st,
	TSN.SITTRIB AS sss_csosn,
	TSN.SITTRIB AS svc_csosn,
	TSN.SITTRIB AS snc_csosn,
	P.ALIQ_FCP AS fecp,
	ISNULL(P.INATIVO,'N') AS status
	
FROM
	CDPRODUTOS P
		INNER JOIN CDALIQUOTA ANF ON P.CODALIQNF = ANF.CODALIQ
		INNER JOIN CDALIQUOTA AECF ON P.CODALIQECF = AECF.CODALIQ
		LEFT JOIN CDTRIBUTACAO T ON P.CODTRIB = T.CODTRIB
		LEFT JOIN CDTRIBUTACAO TSN ON P.CODTRIBSN = TSN.CODTRIB
		LEFT JOIN CDCEST C ON C.ID_CEST = P.ID_CEST

GO
------------------------------------------------------------------------------------------------------------------------------------------

-- **********  CRIAÇÃO DAS PERMISSÕES DE ACESSO **********
GRANT SELECT, UPDATE, INSERT, DELETE ON mxf_tmp_pis_cofins TO MIX_FISCAL
GRANT SELECT, UPDATE, INSERT, DELETE ON mxf_tmp_icms_saida TO MIX_FISCAL
GRANT SELECT, UPDATE, INSERT, DELETE ON mxf_tmp_icms_entrada TO MIX_FISCAL

GRANT SELECT ON mxf_vw_pis_cofins TO MIX_FISCAL
GRANT SELECT ON mxf_vw_icms TO MIX_FISCAL
GO