------------------------------------------------------------------------------------------------------------------------------------------
--ADICIONA COLUNA CEST
IF NOT EXISTS(
SELECT 1 FROM SYS.ALL_COLUMNS C 
INNER JOIN SYSOBJECTS O ON C.OBJECT_ID = O.ID WHERE 
O.ID = OBJECT_ID('mxf_tmp_icms_saida') AND C.NAME = 'cest')
ALTER TABLE mxf_tmp_icms_saida
ADD cest varchar(10)

------------------------------------------------------------------------------------------------------------------------------------------
--ATUALIZANDO IDCEST NO CADASTRO DE PRODUTO SEGUINDO MXF_TMP_ICMS_SAIDA
IF (OBJECT_ID('MXF_SP_ATUALIZA_ICMS_CDPRODUTOS', 'P') IS NOT NULL)
DROP PROCEDURE [dbo].[MXF_SP_ATUALIZA_ICMS_CDPRODUTOS]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[MXF_SP_ATUALIZA_ICMS_CDPRODUTOS]
AS 
DECLARE
	@codigo_produto numeric(11),
	@ean numeric(16),
	@snc_cst varchar(3),
	@snc_alq numeric(7,3),
	@snc_alqst numeric(7,3),	
	@mva numeric(7,3),
	@snc_rbc numeric(7,3),
	@snc_rbcst numeric(7,3),
	@ID_RECUPERADO integer,
	@CODTRIB integer,
	@CODALIQ integer,
	@CODALIQECF integer,	
	@PERCALIQSUBTRIBNF decimal(15,4),
	@CEST varchar(10)
DECLARE cursorMixFiscalSaida CURSOR FOR
SELECT CODIGO_PRODUTO, EAN, SNC_CST, SNC_ALQ, SNC_ALQST, SNC_RBC, SNC_RBCST,REPLACE(CEST,'.','') FROM MXF_TMP_ICMS_SAIDA
OPEN cursorMixFiscalSaida
FETCH NEXT FROM cursorMixFiscalSaida
INTO @codigo_produto,@ean,@snc_cst,@snc_alq,@snc_alqst,@snc_rbc,@snc_rbcst,@cest
WHILE @@FETCH_STATUS = 0
BEGIN	
    -- PESQUISA O ID DO CADASTRO DE CEST
	SET @cest = (SELECT ID_cest FROM CDCEST WHERE CODCEST = @cest);
	-- PESQUISA O ID NO CADASTRO DE TRIBUTAO
	EXEC MXF_SP_RECUPERA_PK_TRIBUTACAO @snc_cst, @ID_RECUPERADO = @ID_RECUPERADO OUTPUT;
	SET @CODTRIB = @ID_RECUPERADO;
	-- PESQUISA O ID NO CADASTRO DE ALQUOTA
	EXEC MXF_SP_RECUPERA_PK_ALIQUOTA @snc_alq, 0, @ID_RECUPERADO = @ID_RECUPERADO OUTPUT;	
	SET @CODALIQ = @ID_RECUPERADO;	
	-- PESQUISA O ID NO CADASTRO DE ALQUOTA DO ECF
	IF(@snc_cst = '60' OR @snc_cst = '70')
	BEGIN
		SET @CODALIQECF = (SELECT TOP(1) CODALIQ FROM CDALIQUOTA WHERE DESCRECF LIKE 'F%')
	END
	ELSE
	BEGIN
		EXEC MXF_SP_RECUPERA_PK_ALIQUOTA @snc_alq, @snc_rbc, @ID_RECUPERADO = @ID_RECUPERADO OUTPUT;	
		SET @CODALIQECF = @ID_RECUPERADO;	
	END
	
	UPDATE CDPRODUTOS
	SET 
		CODTRIB = @CODTRIB,
		CODALIQ = @CODALIQ,
		CODALIQNF = @CODALIQ,
		CODALIQECF = @CODALIQECF,		
		PERCALIQSUBTRIBNF = @snc_alqst, -- ALIQ DE ST
		PERCREDUC = @snc_rbc,
		PERCREDUCST = @snc_rbcst,
		ID_CEST = @CEST,
		DTALTER = CONVERT(DATE, GETDATE(), 103),
		HRALTER = CONVERT(TIME, GETDATE(), 114)
	WHERE CODPROD = @codigo_produto	
FETCH NEXT FROM cursorMixFiscalSaida 
INTO @codigo_produto,@ean,@snc_cst,@snc_alq,@snc_alqst,@snc_rbc,@snc_rbcst,@cest
END
CLOSE cursorMixFiscalSaida
DEALLOCATE cursorMixFiscalSaida