------------------------------------------------------------------------------------------------------------------------------------------
/****** Object:  View [dbo].[mxf_vw_icms]    Script Date: 06/02/2018 10:08:51 ******/
IF (OBJECT_ID('mxf_vw_icms', 'V') IS NOT NULL)
DROP VIEW [dbo].[mxf_vw_icms]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-- ICMS
CREATE VIEW [dbo].[mxf_vw_icms]
AS
SELECT
	P.CODPROD AS codigo_produto, P.CODBARRA AS ean, NULL AS tipo_mva, P.PERCALIQSUBTRIB AS mva,
	SUBSTRING(T.SITTRIB, 2,2) AS sac_cst, c.CODCEST as cest,ANF.PERCENTUAL AS sac_alq, P.PERCALIQSUBTRIB AS sac_alq_st, P.PERCREDUC AS sac_rbc, NULL AS sac_rbc_st, 
	SUBSTRING(T.SITTRIB, 2,2) AS sas_cst, ANF.PERCENTUAL AS sas_alq, P.PERCALIQSUBTRIB AS sas_alq_st, P.PERCREDUC AS sas_rbc, NULL AS sas_rbc_st, 
	SUBSTRING(T.SITTRIB, 2,2) AS svc_cst, ANF.PERCENTUAL AS svc_alq, P.PERCALIQSUBTRIB AS svc_alq_st, P.PERCREDUC AS svc_rbc, NULL AS svc_rbc_st, 
	SUBSTRING(T.SITTRIB, 2,2) AS snc_cst, AECF.PERCENTUAL AS snc_alq, P.PERCALIQSUBTRIB AS snc_alq_st, P.PERCREDUC AS snc_rbc, NULL AS snc_rbc_st,
	TSN.SITTRIB AS sss_csosn,
	TSN.SITTRIB AS svc_csosn,
	TSN.SITTRIB AS snc_csosn
	
FROM
	CDPRODUTOS P
		INNER JOIN CDALIQUOTA ANF ON P.CODALIQNF = ANF.CODALIQ
		INNER JOIN CDALIQUOTA AECF ON P.CODALIQECF = AECF.CODALIQ
		LEFT JOIN CDTRIBUTACAO T ON P.CODTRIB = T.CODTRIB
		LEFT JOIN CDTRIBUTACAO TSN ON P.CODTRIBSN = TSN.CODTRIB
		LEFT JOIN CDCEST C ON C.ID_CEST = P.ID_CEST

GO
------------------------------------------------------------------------------------------------------------------------------------------
/****** Object:  StoredProcedure [dbo].[MXF_SP_RECUPERA_PK_CST_COFINS]    Script Date: 14/11/2017 10:16:38 ******/
IF (OBJECT_ID('MXF_SP_RECUPERA_PK_CST_COFINS', 'P') IS NOT NULL)
DROP PROCEDURE [dbo].[MXF_SP_RECUPERA_PK_CST_COFINS]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-- RECUPERAÇÃO DA PK DA TABELA DE CADASTRO DE CST DE COFINS
CREATE PROCEDURE [dbo].[MXF_SP_RECUPERA_PK_CST_COFINS]
	@CST VARCHAR(3),
	@TIPOES CHAR(1),
	@ID_RECUPERADO INT OUT
AS
IF((SELECT COUNT(*) FROM fis_cst_cofins
		WHERE cod_cst_cofins = '' + @CST + '') > 0)
BEGIN
	SET @ID_RECUPERADO = 
	(SELECT TOP (1) id_fis_cst_cofins FROM fis_cst_cofins WHERE cod_cst_cofins = '' + @CST + '');
END
ELSE
BEGIN
	INSERT INTO fis_cst_cofins (cod_cst_cofins, descricao, tipoes, tipooperacao)
	VALUES ('' + @CST + '','Importado Mix Fiscal', '' + @TIPOES + '', 'N');
	IF((SELECT COUNT(*) FROM fis_cst_cofins
		WHERE cod_cst_cofins = '' + @CST + '') > 0)
	BEGIN
		SET @ID_RECUPERADO = 
			(SELECT TOP(1) id_fis_cst_cofins FROM fis_cst_cofins WHERE cod_cst_cofins = '' + @CST + '');
	END
	ELSE
	BEGIN
		SET @ID_RECUPERADO = NULL;
	END
END

GO
------------------------------------------------------------------------------------------------------------------------------------------
/****** Object:  StoredProcedure [dbo].[MXF_SP_RECUPERA_PK_CST_PIS]    Script Date: 14/11/2017 10:26:04 ******/
IF (OBJECT_ID('MXF_SP_RECUPERA_PK_CST_PIS', 'P') IS NOT NULL)
DROP PROCEDURE [dbo].[MXF_SP_RECUPERA_PK_CST_PIS]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-- RECUPERAÇÃO DA PK DA TABELA DE CADASTRO DE CST DE PIS
CREATE PROCEDURE [dbo].[MXF_SP_RECUPERA_PK_CST_PIS]
	@CST VARCHAR(3),
	@TIPOES CHAR(1),
	@ID_RECUPERADO INT OUT
AS
IF((SELECT COUNT(*) FROM fis_cst_pis
		WHERE cod_cst_pis = '' + @CST + '') > 0)
BEGIN
	SET @ID_RECUPERADO = 
	(SELECT TOP(1) id_fis_cst_pis FROM fis_cst_pis WHERE cod_cst_pis= '' + @CST + '');
END
ELSE
BEGIN
	INSERT INTO fis_cst_pis (cod_cst_pis, descricao, tipoes, tipooperacao)
	VALUES ('' + @CST + '','Importado Mix Fiscal', '' + @TIPOES + '', 'N');
	IF((SELECT COUNT(*) FROM fis_cst_pis
		WHERE cod_cst_pis = '' + @CST + '') > 0)
	BEGIN
		SET @ID_RECUPERADO = (SELECT top(1) id_fis_cst_pis FROM fis_cst_pis WHERE cod_cst_pis = '' + @CST + '');
	END
	ELSE
	BEGIN
		SET @ID_RECUPERADO = NULL;
	END
END

GO

------------------------------------------------------------------------------------------------------------------------------------------
/****** Object:  StoredProcedure [dbo].[MXF_SP_RECUPERA_PK_TRIBUTACAO]    Script Date: 14/11/2017 10:17:28 ******/
IF (OBJECT_ID('MXF_SP_RECUPERA_PK_TRIBUTACAO', 'P') IS NOT NULL)
DROP PROCEDURE [dbo].[MXF_SP_RECUPERA_PK_TRIBUTACAO]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-- RECUPERAÇÃO DA PK DA TABELA DE CADASTRO DE TRIBUTAÇÃO
CREATE PROCEDURE [dbo].[MXF_SP_RECUPERA_PK_TRIBUTACAO]
	@CST VARCHAR(3),
	@ID_RECUPERADO INT OUT
AS
DECLARE
	@ORIGEM_CST VARCHAR(3)
IF(LEN(@CST) = 2)
BEGIN
	SET @ORIGEM_CST = '0' + @CST;
END
ELSE
BEGIN
	IF (LEN(@CST) = 1)
	BEGIN
		SET @ORIGEM_CST = '00' + @CST;
	END
	ELSE
	BEGIN
		SET @ORIGEM_CST = @CST;
	END
END
IF((SELECT COUNT(*) FROM CDTRIBUTACAO WHERE SITTRIB = '' + @ORIGEM_CST + '') > 0)
BEGIN
	SET @ID_RECUPERADO = (SELECT TOP(1) CODTRIB FROM CDTRIBUTACAO WHERE SITTRIB = '' + @ORIGEM_CST + '');
END
ELSE
BEGIN
	SET @ID_RECUPERADO = NULL;
END

GO

------------------------------------------------------------------------------------------------------------------------------------------
--ADICIONA COLUNAS DE CSOSN PARA SIMPLES NACIONAL e Cest
ALTER TABLE mxf_tmp_icms_saida
ADD sss_csosn varchar(4), svc_csosn varchar(4), snc_csosn varchar(4), cest varchar(10)

------------------------------------------------------------------------------------------------------------------------------------------
--UPDATE MXF_SP_ATUALIZA_ICMS_CDPRODUTOS ADICIONA COLUNA CSOSN

/****** Object:  View [dbo].[MXF_SP_ATUALIZA_ICMS_CDPRODUTOS]    Script Date: 06/02/2018 10:08:51 ******/
IF (OBJECT_ID('MXF_SP_ATUALIZA_ICMS_CDPRODUTOS', 'P') IS NOT NULL)
DROP PROCEDURE [dbo].[MXF_SP_ATUALIZA_ICMS_CDPRODUTOS]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[MXF_SP_ATUALIZA_ICMS_CDPRODUTOS]
AS 

DECLARE
	@codigo_produto numeric(11),
	@ean numeric(16),
	@snc_cst varchar(3),
	@snc_alq numeric(7,3),
	@snc_alqst numeric(7,3),	
	@mva numeric(7,3),
	@snc_rbc numeric(7,3),
	@snc_rbcst numeric(7,3),
	@ID_RECUPERADO integer,
	@CODTRIB integer,
	@CODALIQ integer,
	@CODALIQECF integer,	
	@PERCALIQSUBTRIBNF decimal(15,4),
	@snc_csosn varchar(4),
	@CODTRIBSN integer,
	@CEST varchar(10)
DECLARE cursorMixFiscalSaida CURSOR FOR
SELECT CODIGO_PRODUTO, EAN, SNC_CST, SNC_ALQ, SNC_ALQST, SNC_RBC, SNC_RBCST, SNC_CSOSN,REPLACE(CEST,'.','') FROM MXF_TMP_ICMS_SAIDA
OPEN cursorMixFiscalSaida
FETCH NEXT FROM cursorMixFiscalSaida
INTO @codigo_produto,@ean,@snc_cst,@snc_alq,@snc_alqst,@snc_rbc,@snc_rbcst, @snc_csosn,@cest
WHILE @@FETCH_STATUS = 0
BEGIN	
    -- PESQUISA O ID DO CADASTRO DE CEST
	SET @cest = (SELECT ID_CEST FROM CDCEST WHERE CODCEST = @cest);
	-- PESQUISA O ID NO CADASTRO DE TRIBUTAÇÃO
	EXEC MXF_SP_RECUPERA_PK_TRIBUTACAO @snc_cst, @ID_RECUPERADO = @ID_RECUPERADO OUTPUT;
	SET @CODTRIB = @ID_RECUPERADO;
	-- PESQUISA O ID NO CADASTRO DE TRIBUTAÇÃO
	EXEC MXF_SP_RECUPERA_PK_TRIBUTACAO @snc_csosn, @ID_RECUPERADO = @ID_RECUPERADO OUTPUT;
	SET @CODTRIBSN = @ID_RECUPERADO;
	-- PESQUISA O ID NO CADASTRO DE ALÍQUOTA
	EXEC MXF_SP_RECUPERA_PK_ALIQUOTA @snc_alq, 0, @ID_RECUPERADO = @ID_RECUPERADO OUTPUT;	
	SET @CODALIQ = @ID_RECUPERADO;	
	-- PESQUISA O ID NO CADASTRO DE ALÍQUOTA DO ECF
	IF(@snc_cst = '60' OR @snc_cst = '70')
	BEGIN
		SET @CODALIQECF = (SELECT TOP(1) CODALIQ FROM CDALIQUOTA WHERE DESCRECF LIKE 'F%')
	END
	ELSE
	BEGIN
		EXEC MXF_SP_RECUPERA_PK_ALIQUOTA @snc_alq, @snc_rbc, @ID_RECUPERADO = @ID_RECUPERADO OUTPUT;	
		SET @CODALIQECF = @ID_RECUPERADO;	
	END
	
	UPDATE CDPRODUTOS
	SET 
		CODTRIB = @CODTRIB,
		CODTRIBSN = @CODTRIBSN,
		CODALIQ = @CODALIQ,
		CODALIQNF = @CODALIQ,
		CODALIQECF = @CODALIQECF,		
		PERCALIQSUBTRIBNF = @snc_alqst, -- ALIQ DE ST
		PERCREDUC = @snc_rbc,
		PERCREDUCST = @snc_rbcst,
		ID_CEST = @CEST,
		DTALTER = CONVERT(DATE, GETDATE(), 103),
		HRALTER = CONVERT(TIME, GETDATE(), 114)
	WHERE CODPROD = @codigo_produto	
FETCH NEXT FROM cursorMixFiscalSaida 
INTO @codigo_produto,@ean,@snc_cst,@snc_alq,@snc_alqst,@snc_rbc,@snc_rbcst, @snc_csosn,@cest
END
CLOSE cursorMixFiscalSaida
DEALLOCATE cursorMixFiscalSaida

DECLARE cursorMixFiscalEntrada CURSOR FOR
-- PESQUISA SOMENTE O MVA PREENCHIDO POIS CASO SEJA NULO NÃO DEVERÁ SER GRAVADO	
SELECT CODIGO_PRODUTO, EAN, MVA FROM MXF_TMP_ICMS_ENTRADA WHERE MVA IS NOT NULL
OPEN cursorMixFiscalEntrada
FETCH NEXT FROM cursorMixFiscalEntrada
INTO @codigo_produto,@ean,@mva
WHILE @@FETCH_STATUS = 0
BEGIN		
	UPDATE CDPRODUTOS
	SET 		
		PERCALIQSUBTRIB = @mva, -- MVA
		DTALTER = CONVERT(DATE, GETDATE(), 103),
		HRALTER = CONVERT(TIME, GETDATE(), 114)
	WHERE CODPROD = @codigo_produto	
FETCH NEXT FROM cursorMixFiscalEntrada 
INTO @codigo_produto,@ean,@mva
END
CLOSE cursorMixFiscalEntrada
DEALLOCATE cursorMixFiscalEntrada
GO

